# Copyright (c) 2000-2010, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%define section free

%define with_maven %{!?_without_maven:1}%{?_without_maven:0}
%define without_maven %{?_without_maven:1}%{!?_without_maven:0}

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_without maven
%bcond_without repolib

%define repodir %{_javadir}/repository.jboss.com/org/apache/ws/security/%{name}/%{version}-patch-02-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

Name:           wss4j
Version:        1.5.12
Release:        4.2_patch_02%{?dist}
Epoch:          0
Summary:        Implementation of the OASIS Web Services Security
License:        ASL 2.0
Group:          Development/Libraries/Java
URL:            http://ws.apache.org/wss4j/
# svn export http://svn.apache.org/repos/asf/webservices/wss4j/tags/1_5_12/ wss4j-1.5.12
# Exported revision 1371746.
# tar czf wss4j-1.5.12.tar.gz wss4j-1.5.12
Source0:        %{name}-%{version}.tar.gz
Source1:	%{name}-component-info.xml
Source2:        %{name}-settings.xml
Source3:        %{name}-jpp-depmap.xml
Patch0:         wss4j-1.5.8-build.patch
Patch2:		wss4j-pom.patch
Patch3:		wss4j-CVE-2011-1096.patch
Patch4:		wss4j-CVE-2011-2487.patch
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       java >= 0:1.5.0
#Mark bouncycastle and axis as Optional: 
#Optional:       axis >= 0:1.4
#Requires:       bouncycastle-provider >= 0:1.37
#Optional:	bouncycastle
Requires:       jakarta-commons-codec >= 0:1.3
Requires:       jakarta-commons-discovery >= 0:0.2
Requires:       jakarta-commons-httpclient >= 0:3.0.1
Requires:       jakarta-commons-logging >= 0:1.1
Requires:       log4j >= 0:1.2.8
#Mark opensaml as Optional: 
#Optional:       opensaml >= 0:1.1b
Requires:       wsdl4j >= 0:1.6.2
Requires:       xalan-j2 >= 0:2.7.0
Requires:       xerces-j2 >= 0:2.9.0
Requires:       xml-commons-jaxp-1.3-apis
Requires:       xml-security >= 0:1.3.0
BuildRequires:  jpackage-utils >= 0:1.7.3
#BuildRequires:  java-1.5.0-sun-jce-policy
BuildRequires:  java-devel
BuildRequires:  ant >= 0:1.6.5
BuildRequires:  ant-junit
BuildRequires:  junit
%if %with maven
BuildRequires:  apache-jar-resource-bundle >= 0:1.4
BuildRequires:  maven2 >= 0:2.0.8
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-enforcer
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-source
BuildRequires:  maven-doxia-sitetools
BuildRequires:  maven-release
BuildRequires:  maven-enforcer-rule-api
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit
BuildRequires:  maven2-plugin-checkstyle
BuildRequires:  maven2-plugin-pmd
BuildRequires:  maven2-plugin-remote-resources
BuildRequires:  maven-jxr
BuildRequires:  felix-maven2
#BuildRequires:  maven-plugin-jdepend 
#BuildRequires:  maven-plugin-license 
#BuildRequires:  maven-plugin-xdoc
%endif
BuildRequires:  axis >= 0:1.4
BuildRequires:  bouncycastle >= 0:1.43
BuildRequires:	glassfish-jaf
BuildRequires:	glassfish-javamail
BuildRequires:  jakarta-commons-codec >= 0:1.3
BuildRequires:  jakarta-commons-discovery >= 0:0.2
BuildRequires:  jakarta-commons-httpclient >= 0:3.0.1
BuildRequires:  jakarta-commons-logging >= 0:1.1
BuildRequires:  log4j >= 0:1.2.8
BuildRequires:  opensaml >= 0:1.1b
BuildRequires:  objectweb-asm >= 0:3.1
BuildRequires:  wsdl4j >= 0:1.6.2
BuildRequires:  xalan-j2 >= 0:2.7.0
BuildRequires:  xerces-j2 >= 0:2.9.0
BuildRequires:  xml-commons-jaxp-1.3-apis
BuildRequires:  xml-security >= 0:1.3.0
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root
BuildArch:      noarch

%description 
Apache WSS4J is an implementation of the OASIS Web Services Security
(WS-Security) from OASIS Web Services Security TC. WSS4J is a
primarily a Java library that can be used to sign and verify SOAP
Messages with WS-Security information. WSS4J will use Apache Axis and
Apache XML-Security projects and will be interoperable with JAX-RPC
based server/clients and .NET server/clients.

Note: To use with axis, bouncycastle, and opensaml, please add the jar to
the Classpath.
%package javadoc
Group:          Development/Documentation
Summary:        Javadoc for %{name}

%description javadoc
Javadoc for %{name}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q 
%patch0 -b .sav0
%patch2 -b .sav0
%patch3 -b .sav0
%patch4 -b .sav0

find -type f -name "*.jar" | xargs -t rm

# set JAVA_HOME for build-classpath to work properly
export JAVA_HOME=%{java_home}

%if %without maven
ln -s $(build-classpath axis/axis) lib
ln -s $(build-classpath axis/axis-ant) lib
ln -s $(build-classpath axis/jaxrpc) lib
ln -s $(build-classpath axis/saaj) lib
#ln -s $(build-classpath bouncycastle/bcprov) lib
ln -s $(build-classpath bcprov) lib
ln -s $(build-classpath commons-codec) lib
ln -s $(build-classpath commons-discovery) lib
ln -s $(build-classpath commons-httpclient) lib
ln -s $(build-classpath commons-logging) lib
ln -s $(build-classpath glassfish-jaf) lib
ln -s $(build-classpath glassfish-javamail) lib
ln -s $(build-classpath junit) lib
ln -s $(build-classpath log4j) lib
ln -s $(build-classpath opensaml) lib
ln -s $(build-classpath wsdl4j) lib
ln -s $(build-classpath xalan-j2) lib
ln -s $(build-classpath xalan-j2-serializer) lib
ln -s $(build-classpath xml-security) lib

ln -s $(build-classpath xerces-j2) endorsed
ln -s $(build-classpath xml-commons-jaxp-1.3-apis) endorsed

%else
cp -p %{SOURCE2} maven2-settings.xml

sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" maven2-settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" maven2-settings.xml

mkdir external_repo
ln -s %{_javadir} external_repo/JPP
%endif

%build
export JAVA_HOME=%{java_home}
%if %without maven
%{ant} -d -v jar javadoc
%else
mkdir -p target/work

#Copy crypto.properties to a location that is searched
mkdir -p target/test-classes
cp test/crypto.properties target/test-classes/

export M2SETTINGS=$(pwd)/maven2-settings.xml
export MAVEN_REPO_LOCAL=$(pwd)/m2_repo/repository
%{_bindir}/mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven2.jpp.depmap.file=%{SOURCE3} \
        -Dmaven.test.failure.ignore=true \
        -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
        -DaltDeploymentRepository=jboss-releases::default::file://$(pwd)/maven2-brew \
        install javadoc:javadoc
%endif

%install
rm -rf %{buildroot}

# jars, main package
install -d -m 755 %{buildroot}%{_javadir}
%if %without maven
install -p -m 644 build/wss4j-%{version}-patch-02.jar %{buildroot}%{_javadir}/%{name}-%{version}-patch-02.jar
%else
install -p -m 644 target/%{name}-%{version}-patch-02.jar %{buildroot}%{_javadir}/%{name}-%{version}-patch-02.jar
install -p -m 644 target/%{name}-%{version}-patch-02-javadoc.jar %{buildroot}%{_javadir}/%{name}-javadoc-%{version}-patch-02.jar
%add_to_maven_depmap org.apache.ws.security wss4j %{version}-patch-02 JPP %{name}
%endif

%{jar} -cf %{buildroot}%{_javadir}/%{name}-sources-%{version}-patch-02.jar -C src/ .

ln -s wss4j-%{version}-patch-02.jar %{buildroot}%{_javadir}/%{name}.jar
ln -s wss4j-sources-%{version}-patch-02.jar %{buildroot}%{_javadir}/%{name}-sources.jar
%if %with maven
ln -s wss4j-javadoc-%{version}-patch-02.jar %{buildroot}%{_javadir}/%{name}-javadoc.jar
%endif

# pom
install -d -m 755 %{buildroot}%{_datadir}/maven2/poms
install -p -m 644 pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}.pom

# javadoc
install -d -m 755 %{buildroot}/%{_javadocdir}/%{name}-%{version}
%if %without maven
cp -pr build/doc/html/api/* %{buildroot}/%{_javadocdir}/%{name}-%{version}
%else
cp -pr target/site/apidocs/* %{buildroot}/%{_javadocdir}/%{name}-%{version}
%endif
ln -s %{name}-%{version} %{buildroot}/%{_javadocdir}/%{name}

%if %with repolib
%if 0
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{__cp} -pr maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%endif
%{__install} -d -m 755 %{buildroot}%{repodir}
%{__install} -d -m 755 %{buildroot}%{repodirlib}
%{__install} -p -m 644 %{SOURCE1} %{buildroot}%{repodir}/component-info.xml
tag=`/bin/echo %{name}-%{version}-%{release} | %{__sed} 's|\.|_|g'`
%{__sed} -i "s/@TAG@/$tag/g" %{buildroot}%{repodir}/component-info.xml
%{__sed} -i "s/@VERSION@/%{version}-brew/g" %{buildroot}%{repodir}/component-info.xml
%{__install} -d -m 755 %{buildroot}%{repodirsrc}
%{__install} -p -m 644 %{SOURCE0} %{buildroot}%{repodirsrc}
%{__install} -p -m 644 %{PATCH0} %{buildroot}%{repodirsrc}
%{__install} -p -m 644 %{PATCH2} %{buildroot}%{repodirsrc}
%{__install} -p -m 644 %{PATCH3} %{buildroot}%{repodirsrc}
%{__install} -p -m 644 %{PATCH4} %{buildroot}%{repodirsrc}
%{__cp} -p %{buildroot}%{_javadir}/%{name}-%{version}-patch-02.jar %{buildroot}%{repodirlib}/%{name}.jar
%{__cp} -p pom.xml %{buildroot}%{repodirlib}/%{name}.pom
%{__cp} -p %{buildroot}%{_javadir}/%{name}-sources-%{version}-patch-02.jar %{buildroot}%{repodirlib}/%{name}-sources.jar
%if %with maven
%{__cp} -p %{buildroot}%{_javadir}/%{name}-javadoc-%{version}-patch-02.jar %{buildroot}%{repodirlib}/%{name}-javadoc.jar
%endif
%endif

%clean
rm -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%dir %{_javadir}
%{_javadir}/%{name}-%{version}-patch-02.jar
%{_javadir}/%{name}.jar
%{_javadir}/%{name}-sources-%{version}-patch-02.jar
%{_javadir}/%{name}-sources.jar
%if %with maven
%{_javadir}/%{name}-javadoc-%{version}-patch-02.jar
%{_javadir}/%{name}-javadoc.jar
%endif
%{_datadir}/maven2/poms/JPP-%{name}.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}
%{_javadir}/repository.jboss.com
%endif

%changelog
* Tue Dec 04 2012 Hui Wang <huwang@redhat.com> 0:1.5.12-4.2_patch_02
- Fix release version and update source conmment 

* Fri Nov 30 2012 Permaine Cheung <pcheung@redhat.com> 0:1.5.12-4.1_patch_02
- Fix version in upload.sh to -patch-02

* Thu Nov 29 2012 Permaine Cheung <pcheung@redhat.com> 0:1.5.12-3.1_patch_02
- Add patch for CVE-2011-2487
- Change repolib location to -patch-02

* Fri Aug 10 2012 Permaine Cheung <pcheung@redhat.com> 0:1.5.12-2.1_patch_01
- Add -patch-01 to repolib location
- Add new patch to repolib

* Fri Aug 10 2012 Permaine Cheung <pcheung@redhat.com> 0:1.5.12-1_patch_01
- 1.5.12_patch_01 (with fix for CVE-2011-1096)
- Remove wss4j-security.patch as it is already incorporated in the tag

* Mon Jun 6 2011 Yiqiao Wang <yiwang@redhat.com> 0:1.5.10-3_patch_01
- Patch pom.xml to have version 1.5.10_patch_01
- Modify spec file so that jars have -patch-01 in their versions

* Fri Jun 3 2011 Yiqiao Wang <yiwang@redhat.com> 0:1.5.10-1.patch_01.1
- Upgrade to 1.5.10
- Apply wss4j-security.patch (JBPAPP-6642)
- Modify wss4j-1.5.8-build.patch
- Remove dependency on ws-fx-addressing

* Tue Jun 29 2010 Permaine Cheung <pcheung@redhat.com> 0:1.5.8-5
- Mark axis as Optional Requires

* Mon Jun 28 2010 Permaine Cheung <pcheung@redhat.com> 0:1.5.8-4
- Mark bouncycastle and opensaml as Optional Requires

* Mon Jun 07 2010 David Walluck <dwalluck@redhat.com> 0:1.5.8-3
- enable maven-remote-resources-plugin

* Mon Jun 07 2010 David Walluck <dwalluck@redhat.com> 0:1.5.8-2
- fix build

* Wed Jun 02 2010 Fernando Nasser fnasser@redhat.com> 0:1.5.8-1
- Upgrade to 1.5.8
- Upgrade build to maven2

* Wed Dec 09 2009 Martha Benitez <mbenitez@redhat.com> 0:1.5.7-2
- Add BR glassfish-jaf, glassfish-javamail
- Fix repolib location
- Uncomment project.patch, to use the current project version
- Add pom.xml to repolib
- Add fix for failing test copying crypto.properties to a proper location
- Add sources jar file to main package and repolib

* Thu Jul 30 2009 Martha Benitez <mbenitez@redhat.com> 0:1.5.7-1
- Upgrade to 1.5.7
- Comment 1.5.3 patches
- Change (B)R bouncycastle-provider to bouncycastle
- Add repolib

* Fri Jul 24 2009 Martha Benitez <mbenitez@redhat.com> 0:1.5.3-1.1
- Adjust release tag
- Change jpackage-utils >= 0:1.7.4 to jpackage-utils >= 0:1.7.3
- Comment out: java-1.5.0-sun-jce-policy, bouncycastle-provider
- Add build-classpath junit

* Fri Mar 28 2008 Ralph Apel <r.apel at r-apel.de> 0:1.5.3-1jpp
- 1.5.3
- Drop ws-commons-policy and ws-commons-neethi (B)Rs
- Build with maven1 by default

* Wed Oct 10 2007 Ralph Apel <r.apel at r-apel.de> 0:1.5.0-3jpp
- (B)R bouncycastle-provider instead of bouncycastle-jdk1.X
- (B)R ws-commons-neethi, as a way of avoiding usage of old neethi
  package to satisfy ws-commons-policy (B)R

* Wed Jul 11 2007 Ralph Apel <r.apel at r-apel.de> 0:1.5.0-2jpp
- Replace neethi (B)R by ws-commons-policy

* Wed May 24 2006 Deepak Bhole <dbhole@redhat.com> 0:1.5.0-1jpp
- Upgrade to 1.5.0

* Mon Jan 16 2006 Deepak Bhole <dbhole@redhat.com> 0:1.1.1-0.20060117.1jpp
- Upgrade to 1.1.1 snapshot

* Thu Oct 20 2005 Deepak Bhole <dbhole@redhat.com> 0:1.1.0-1jpp
- Initial build.

